import { renderless, api } from '@opentinyvue/vue-renderless/calendar-view/vue';
import { defineComponent, props, setup } from '@opentinyvue/vue-common';
import Button from '@opentinyvue/vue-button';
import DatePicker from '@opentinyvue/vue-date-picker';
import RadioButton from '@opentinyvue/vue-radio-button';
import RadioGroup from '@opentinyvue/vue-radio-group';
import Tooltip from '@opentinyvue/vue-tooltip';
import { iconCheckedSur, iconPlus, iconChevronLeft, iconChevronRight, iconDayView, iconAgendaView, iconMonthView } from '@opentinyvue/vue-icon';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-calendar-view",
    style: {
      "height": typeof _vm.height === "number" ? _vm.height + "px" : _vm.height
    }
  }, [_c("div", {
    staticClass: "tiny-calendar-view__header"
  }, [_c("div", [_c("tiny-button", {
    on: {
      "click": _vm.toToday
    }
  }, [_vm._v(_vm._s(_vm.t("ui.calendarView.backToday")))])], 1), _c("tiny-date-picker", {
    staticClass: "tiny-calendar-view__picker",
    attrs: {
      "type": "month",
      "clearable": false,
      "format": _vm.t("ui.calendarView.dateFormat")
    },
    on: {
      "change": _vm.currentDateChange
    },
    model: {
      value: _vm.state.currentDate,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "currentDate", $$v);
      },
      expression: "state.currentDate"
    }
  }), _c("div", {
    staticClass: "tiny-calendar-view__tool"
  }, [_vm._t("tool")], 2), _vm.modes.length ? _c("tiny-radio-group", {
    staticClass: "tiny-calendar-view__radio",
    attrs: {
      "size": "mini"
    },
    model: {
      value: _vm.state.mode,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "mode", $$v);
      },
      expression: "state.mode"
    }
  }, _vm._l(_vm.modes, function(mode) {
    return _c("tiny-radio-button", {
      key: mode,
      attrs: {
        "label": mode
      }
    }, [_c(_vm.state.modesIcon[mode], {
      tag: "component",
      class: _vm.state.mode === mode && "fill-brand"
    })], 1);
  }), 1) : _vm._e()], 1), _vm.state.mode === "month" ? _c("div", {
    staticClass: "tiny-calendar-view-month"
  }, [_c("div", {
    staticClass: "tiny-calendar-view-month__header"
  }, [_c("div", {
    staticClass: "header-left",
    on: {
      "click": _vm.goPrevMonth
    }
  }, [_c("icon-chevron-left")], 1), _c("ul", {
    staticClass: "header-main"
  }, _vm._l(_vm.state.weekDays, function(day) {
    return _c("li", {
      key: day
    }, [_c("span", [_vm._v(_vm._s(_vm.t("ui.calendarView.weekDays." + day)))])]);
  }), 0), _c("div", {
    staticClass: "header-right",
    on: {
      "click": _vm.goNextMonth
    }
  }, [_c("icon-chevron-right")], 1)]), _c("div", {
    staticClass: "tiny-calendar-view-month__main"
  }, [_c("div", {
    staticClass: "main-container"
  }, _vm._l(_vm.state.calendar, function(item, index) {
    return _c("ul", {
      key: index
    }, _vm._l(item, function(day, i) {
      return _c("li", {
        key: i,
        class: [i === 0 || i === 6 ? "is-weekends" : "", day.isLast || day.isNext || day.disabled ? "" : _vm.isSelectedDate(day) ? "is-selected" : "not-selected", "bg-" + _vm.getDayBgColor(day)],
        style: {
          "width": "14.2857%"
        },
        on: {
          "click": function click($event) {
            return _vm.selectDay(day);
          }
        }
      }, [_vm.multiSelect && _vm.isSelectedDate(day) ? _c("div", {
        staticClass: "day-selected"
      }, [_c("icon-checked-sur")], 1) : _vm._e(), _c("div", {
        staticClass: "date",
        class: [day.isLast || day.isNext ? "is-next-or-last" : _vm.isToday(day) || _vm.isSelectedDate(day) ? "is-selected" : "", day.disabled ? "is-disabled" : ""]
      }, [_vm._v(" " + _vm._s(_vm.isToday(day) ? _vm.t("ui.datepicker.today") : day.value) + " ")]), _c("div", {
        staticClass: "day-events",
        staticStyle: {
          "max-height": "calc(100% - 26px)"
        }
      }, _vm._l(_vm.getEventByTime(day, _vm._constants.DAY_START_TIME, _vm._constants.DAY_END_TIME), function(event, idx) {
        return _c("div", {
          key: idx,
          staticClass: "events-container",
          on: {
            "mouseenter": function mouseenter($event) {
              return _vm.handleMouseenter($event, event);
            },
            "mouseleave": function mouseleave($event) {
              return _vm.handleMouseleave($event, event);
            }
          }
        }, [_vm.isStartOrEndDay("start", day.value, _vm._constants.DAY_START_TIME, _vm._constants.DAY_END_TIME, event) ? _c("div", {
          staticClass: "events-start",
          class: event.dayNumber > 1 && "multi-day"
        }, [_c("span", {
          staticClass: "events-title",
          class: event.theme ? "theme-" + event.theme : ""
        }, [_vm._v(" " + _vm._s(event.title) + " ")])]) : _c("div", {
          staticClass: "events-end",
          class: [_vm.isStartOrEndDay("end", day.value, _vm._constants.DAY_START_TIME, _vm._constants.DAY_END_TIME, event) ? "is-end" : "", event.theme ? "bg-" + event.theme : ""]
        })]);
      }), 0)]);
    }), 0);
  }), 0)])]) : _c("div", {
    staticClass: "tiny-calendar-view-week"
  }, [_c("div", {
    staticClass: "tiny-calendar-view-week__header"
  }, [_c("div", {
    staticClass: "header-left",
    on: {
      "click": _vm.getPrevWeek
    }
  }, [_c("icon-chevron-left")], 1), _c("ul", {
    staticClass: "header-main"
  }, _vm._l(_vm.state.weekDates, function(date, index) {
    return _c("li", {
      key: date.value,
      on: {
        "click": function click($event) {
          return _vm.selectDay(date);
        }
      }
    }, [_vm._t("header", function() {
      return [_c("span", {
        staticClass: "date",
        class: [_vm.dateIsToday(date.value) && "is-today", {
          current: _vm.computedSelectDay(date)
        }]
      }, [_c("span", [_vm._v(_vm._s(date.value.split("-")[2]))]), _vm.isShowMark(date.value) ? _c("span", {
        staticClass: "mark",
        class: [date.value.split("-")[2] > 9 ? "is-two-digit" : "", _vm.markColor ? "mark-" + _vm.markColor : ""]
      }) : _vm._e()]), _c("span", {
        staticClass: "week-day",
        class: [_vm.dateIsToday(date.value) && "is-today", {
          current: _vm.computedSelectDay(date)
        }]
      }, [_vm._v(_vm._s(_vm.dateIsToday(date.value) ? _vm.t("ui.datepicker.today") : _vm.t("ui.calendarView.weekDays." + index)))])];
    }, {
      "slotScope": {
        date: date.value,
        weekDay: _vm.t("ui.calendarView.weekDays." + index)
      }
    })], 2);
  }), 0), _c("div", {
    staticClass: "header-right",
    on: {
      "click": _vm.getNextWeek
    }
  }, [_c("icon-chevron-right")], 1)]), _vm.state.mode === "timeline" ? _c("div", {
    staticClass: "tiny-calendar-view-week__timeline"
  }, [_c("div", {
    staticClass: "day-times"
  }, [_c("ul", _vm._l(_vm.state.dayTimes, function(item, i) {
    return _c("li", {
      key: item.time,
      class: i % 2 === 1 && "is-odd-num"
    }, [_c("span", [_vm._v(_vm._s(item.text.includes("30") ? "" : item.text))])]);
  }), 0)]), _c("div", {
    staticClass: "day-events"
  }, [_c("ul", _vm._l(_vm.state.weekDates, function(date, index) {
    return _c("li", {
      key: date.value,
      class: index === 0 || index === 6 ? "is-weekends" : "",
      staticStyle: {
        "width": "calc((100% - 10px) / 7)"
      }
    }, [_vm._t("timeline" + (index + 1), function() {
      return [_c("ul", {
        staticClass: "events-list"
      }, _vm._l(_vm.state.dayTimes, function(item, i) {
        return _c("li", {
          key: date.value + item.time,
          class: i % 2 === 0 && "is-even-num"
        }, _vm._l(_vm.getEventByTime(date.value, item.time, _vm.state.dayTimes[i + 1] && _vm.state.dayTimes[i + 1].time), function(event, idx) {
          return _c("div", {
            key: idx,
            staticClass: "events-item",
            class: ["theme-" + (event.theme || "blue")],
            style: {
              "height": event.height + "px",
              "left": event.left + "px",
              "width": "calc(92% - " + event.left + "px)"
            }
          }, [_c("span", [_vm._v(_vm._s(event.title))])]);
        }), 0);
      }), 0)];
    }, {
      "slotScope": {
        date: date.value,
        events: _vm.state.curWeekEvents[date.value]
      }
    })], 2);
  }), 0)])]) : _vm._e(), _vm.state.mode === "schedule" ? _c("div", {
    staticClass: "tiny-calendar-view-week__schedule"
  }, [_c("ul", _vm._l(_vm.state.weekDates, function(date, index) {
    return _c("li", {
      key: date.value,
      staticStyle: {
        "width": "14.28%"
      }
    }, [_vm._t("weekday" + (index + 1), function() {
      return _vm._l(_vm.state.curWeekEvents[date.value] || [], function(event, idx) {
        return _c("div", {
          key: idx,
          staticClass: "day-events"
        }, [_c("div", {
          staticClass: "title"
        }, [_vm._v(_vm._s(event.title))]), _vm.showTipTime ? _c("div", {
          staticClass: "date"
        }, [_vm._v(" " + _vm._s(_vm.getEventShowTime("start", event, date.value)) + " - " + _vm._s(_vm.getEventShowTime("end", event, date.value)) + " ")]) : _vm._e(), _c("p", {
          staticClass: "content"
        }, [_vm._v(_vm._s(event.content || ""))])]);
      });
    }, {
      "slotScope": {
        date: date.value,
        events: _vm.state.curWeekEvents[date.value]
      }
    }), _vm.isShowNewSchedule(date.value) ? _c("div", {
      staticClass: "new-schedule",
      on: {
        "click": function click($event) {
          return _vm.newSchedule(date.value);
        }
      }
    }, [_c("icon-plus"), _c("span", [_vm._v(_vm._s(_vm.t("ui.calendarView.new")))])], 1) : _vm._e()], 2);
  }), 0)]) : _vm._e()]), _c("tiny-tooltip", {
    ref: "tooltip",
    attrs: {
      "popper-class": "tiny-calendar-view-tooltip",
      "effect": "light",
      "placement": "right"
    },
    scopedSlots: _vm._u([{
      key: "content",
      fn: function fn() {
        return [_c("div", {
          staticClass: "tooltip-main"
        }, [_c("div", {
          staticClass: "title"
        }, [_vm._v(_vm._s(_vm.state.eventTipContent.title))]), _vm.showTipTime ? _c("div", {
          staticClass: "date"
        }, [_vm._v(" " + _vm._s(_vm.state.eventTipContent.startDay) + " " + _vm._s(_vm.state.eventTipContent.startTime) + " ~ " + _vm._s(_vm.state.eventTipContent.endDay) + " " + _vm._s(_vm.state.eventTipContent.endTime) + " ")]) : _vm._e(), _c("p", {
          staticClass: "content"
        }, [_vm._v(_vm._s(_vm.state.eventTipContent.content || ""))])])];
      },
      proxy: true
    }])
  })], 1);
};
var staticRenderFns = [];
var __vue2_script = defineComponent({
  emits: ["update:modelValue", "new-schedule", "selected-date-change", "prev-week-click", "next-week-click", "week-change", "year-change", "month-change", "date-click", "mode-change"],
  components: {
    TinyButton: Button,
    IconCheckedSur: iconCheckedSur(),
    IconPlus: iconPlus(),
    IconChevronLeft: iconChevronLeft(),
    IconChevronRight: iconChevronRight(),
    TinyRadioButton: RadioButton,
    TinyRadioGroup: RadioGroup,
    TinyDatePicker: DatePicker,
    TinyTooltip: Tooltip
  },
  props: [].concat(props, ["modelValue", "showMark", "showNewSchedule", "setDayBgColor", "disabled", "mode", "modes", "year", "month", "dayTimes", "events", "height", "markColor", "multiSelect", "showTipTime"]),
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api,
      extendOptions: {
        modesIcon: {
          timeline: iconDayView(),
          schedule: iconAgendaView(),
          month: iconMonthView()
        }
      }
    });
  }
});
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
